// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.    
//----------------------------------------------------------//                        
//                ━▣━━◤HSPE◢━━▣━           \\
//                                                                  //
//         •Made in    : Indonesia                  \\
//         •Create By : @_wanzss                //
//         •Xbox         :  Harringtonlყ            //
//         •Youtube   : Wanze'ϡ                    \\
//          ⌜                                             ⌝        //
//                      🅿🅻🅴🅰🆂🅴,                   \\
//               🅟🅔🅡🅜🅘🅢🅢🅘🅞🅝            //
//            🅵🅸🆁🆂🆃 🅱🅴🅵🅾🆁🅴          \\
//                🅣🅐🅚🅘🅝🅖 🅣🅗🅔               //
//                          🅲🅾🅳🅴                         \\           
//         ⌞                                              ⌟         //
//                                                                  \\
//----------------------------------------------------------\\
#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300
	#ifndef BYPASS_PIXEL_SHADER
		#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
			_centroid in highp vec2 uv0;
			_centroid in highp vec2 uv1;
		#else
			_centroid in vec2 uv0;
			_centroid in vec2 uv1;
		#endif
	#endif
#else
	#ifndef BYPASS_PIXEL_SHADER
		varying vec2 uv0;
		varying vec2 uv1;
	#endif
#endif

varying vec4 color;
varying highp vec3 HSW;
varying highp vec3 HSP;
varying highp vec3 HSL;
varying highp vec3 HSSP;

uniform vec2 FOG_CONTROL;
uniform vec4 FOG_COLOR;
uniform float RENDER_DISTANCE;
uniform float FAR_CHUNKS_DISTANCE;
uniform highp float TIME;

#ifdef FOG
varying vec4 fogColor;
#endif

#include "uniformShaderConstants.h"
#include "util.h"
#include ".room.h"
#include ".function.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;
LAYOUT_BINDING(2) uniform sampler2D TEXTURE_2;

#define Wanze
//#define DEBUG

void main(){
#ifdef BYPASS_PIXEL_SHADER
	gl_FragColor = vec4(0, 0, 0, 0);
	return;
#else 

#if USE_TEXEL_AA
	v4 HSdiff = texture2D_AA(TEXTURE_0, uv0);
#else
	v4 HSdiff = texture2D(TEXTURE_0, uv0);
#endif

#ifdef SEASONS_FAR
	HSdiff.a = 1.0;
#endif

#if USE_ALPHA_TEST
	#ifdef ALPHA_TO_COVERAGE
	#define ALPHA_THRESHOLD 0.05
	#else
	#define ALPHA_THRESHOLD 0.5
	#endif
	if(HSdiff.a < ALPHA_THRESHOLD)
		discard;
#endif
	
vec4 inColor = color;
//---------------------------------Detection---------------------------------//
highp vec2 HSFC = FOG_CONTROL;
highp vec3 Cv = sqrt(inColor.rgb*1.4);
highp vec4 HSFtime = FOG_COLOR;
float sh = uv1.y;
float HStime = texture2D(TEXTURE_1, v2(0., 1.)).r;
HStime = col1((HStime-0.5)*2., 0., 1.0);
float syng = HStime;
float ku = 1.-HStime;
float kpd = .5-sba(.5-HStime);
float nathan = (1.-slap(HSFC.y, 11.));
float HRST = syng*sh;
float HRMT = ku*sh;
float HRSR = kpd*sh;
float HRRN = nathan*sh;
float HRG = 1.-sh;
float HFRSR=slap(xam(nim(1.-HSFtime.b*1.2,1.), 0.),.5);
float look =slap(xam(nim(1.0-HSFtime.r*1.5,1.),.0),1.2);
//--------------------------------------------------------------------------------//
#ifdef Wanze
#if defined(BLEND)
	HSdiff.a *= inColor.a;
#endif

#if !defined(ALWAYS_LIT)
	HSdiff *= texture2D( TEXTURE_1, uv1 );
#endif

#ifndef SEASONS
	#if !USE_ALPHA_TEST && !defined(BLEND)
		HSdiff.a = inColor.a;
	#endif
  HSdiff.rgb *= mix(inColor.rgb,Cv,HRG);
   #else
	vec2 uv = inColor.xy;
	HSdiff.rgb *= mix(vec3(1.0,1.0,1.0), texture2D( TEXTURE_2, uv).rgb*2.0, inColor.b);
	HSdiff.rgb *= inColor.aaa;
	HSdiff.a = 1.;
#endif

//------------------------------------Mapping-------------------------------//
highp vec3 HRC;
highp vec3 HRCN;
highp vec3 HSG = HSS(HSdiff.rgb, mix(1.,.2, sh));
HRC = mix(vec3(1.7), v3(1.1,1.05,1.), HRST);
HRC = mix(HRC, vec3(1.), HRG);
HRCN = mix(vec3(1.), vec3(3.), HRRN);
HRCN = mix(HRCN, v3(1.2), HRMT);
HRCN =mix(HRCN, vec3(1.,.6,-.5), HRSR);
HSdiff.rgb *= HRC;
HSdiff.rgb *= HRCN;
HSdiff.rgb = HSTM(HSdiff.rgb);
HSdiff.rgb = HSS(HSdiff.rgb, 2.2);
HSdiff.rgb *= mix(vec3(1.), HSG, HRRN);
//--------------------------------------------------------------------------------//

//------------------------------------Variabel--------------------------------//

//Float
float shm = uv1.x;
float shs = color.g+.7*(color.g-color.b);
float Weselo = look*sh;
float NHT = mix(1.,.3,HRST);
float SHT = (1.-HRSR);
float GHT = mix(1.,1.2,HRG);
float RHT = mix(1.,2.2,HRRN);
float MHT = mix(1.,1.5,HRMT);
float BOTAC = clamp(pow(length(shm)*1.4, 5.), .0, 1.);

//Vector
vec3 HAW;
vec3 Ex = vec3(1.6);
vec3 HT = vec3(1.2, .2, -.8);
vec3 HRA = vec3(.0, 2.8, 3.);
vec3 HRSD= vec3(.925)+shm*vec3(.086);
vec3 Tch=HT*slap(shm*1.,2.5)*NHT*GHT*RHT*SHT*MHT;

//High Precision
highp vec3 RsN = normalize(cross(dFdx(HSW), dFdy(HSW)));
highp vec3 dir0 = normalize(cross(ddx(HSP), ddy(HSP)));
highp vec3 dir1 = normalize(-HSP);
highp vec3 dir2 = normalize(cross(ddx(HSP),ddy(HSP)));
 
//Correct
HRSD = mix(HRSD, v3(1.), HRMT);
HRSD = mix(HRSD, v3(1.), HRRN);
HRSD = mix(HRSD, v3(.97), HRSR);
HAW = mix(v3(.0,.535,.9), v3(.0,.3,.7), HRSR);
HAW = mix(HAW, v3(.0, .35, .7), HRRN);
HAW = mix(HAW, v3(.05, .2, .4), HRMT);
HAW = mix(HAW, v3(.0,.1,.2), HRG);

//--------------------------------------------------------------------------------//

//--------------------------------Activator-----------------------------------//
#ifdef ALPHA_TEST
if(color.g > color.r){
HSdiff.rgb *= vec3(1.2,1.3,1.2);
shs = color.g*1.2;
HRSD = vec3(.89)+shm*vec3(.16);}
#endif
if(color.r < color.b){}else{
if((.866>sh)||(.604>shs)){
HSdiff.rgb *= HRSD;}
if((.867>sh)||(.608>shs)){
HSdiff.rgb *= HRSD;}
if((.868>sh)||(.6012>shs)){
HSdiff.rgb *= HRSD;}
if((.869>sh)||(.616>shs)){
HSdiff.rgb *= HRSD;}
if((.87>sh)||(.62>shs)){
HSdiff.rgb *= HRSD;}
if((.871>sh)||(.624>shs)){
HSdiff.rgb *= HRSD;}
if((.873>sh)||(.628>shs)){
HSdiff.rgb *= HRSD;}
if((.874>sh)||(.632>shs)){
HSdiff.rgb *= HRSD;}}
#if!defined (BLEND) && defined (ALPHA_TEST)
if(color.a > 0. && color.g > color.b && uv1.y > .8){
HSdiff.rgb *= vec3(.6,.7,.6);}
#endif
#ifndef SEASONS
if(color.b + color.b > color.r + color.g){
HSdiff.a -=.2;
HSdiff.rgb = HAW;
HSdiff.a += inColor.a * (length(HSW) /   RENDER_DISTANCE * +.7);}
#endif
if(HRRN < .2){HSdiff.rgb = mix(HSdiff.rgb,raySun(HSW,HSdiff.rgb),.025*HRSR*max(.0,RsN.y));}
if(!(HSFC.x ==.0)){
HSdiff.rgb += Tch;}else{
HSdiff.rgb = HSS(HSdiff.rgb, 2.);
HSdiff.rgb += HRA*pow(shm*.35,1.5);
HSdiff.rgb *= vec3(1.2);}
HSdiff *= mix(1., 1.2, max(0., dir0.b));
HSdiff.rgb += HSdiff.rgb*clamp(dot(dir2, dir1), .0,.3);
HSdiff.rgb *= mix(vec3(1.), Ex, HFRSR);
if(color.r < color.g){
HSdiff.rgb *= vec3(.78);}

//-------------------------------------Fog--------------------------------------//

float F = clamp(length(-HSW) / RENDER_DISTANCE * 1.,.025,.2);
vec3 Fon = mix(HSdiff.rgb, HSFtime.rgb, F);
HSdiff.rgb = Fon;
float HF = clamp(length(-HSW) / RENDER_DISTANCE *1.2,.0,3.);
vec3 HFon = mix(HSdiff.rgb, HSFtime.rgb*vec3(2.), HF);
HSdiff.rgb = mix(HSdiff.rgb, HFon, HRRN);
float HFP = clamp(length(HSW) / RENDER_DISTANCE *1.4, .15, 1.);
vec3 HFPon = mix(HSdiff.rgb, HSFtime.rgb, HFP);
HSdiff.rgb = mix(HSdiff.rgb, HFPon, HFRSR);
float HFM = clamp(length(HSW) / FAR_CHUNKS_DISTANCE * .1, .4, 1.5);
vec3 HFMon = mix(HSdiff.rgb, FOG_COLOR.rgb, HFM);
HSdiff.rgb = mix(HSdiff.rgb, HFMon, look);

//--------------------------------------------------------------------------------//

//-------------------------------STUPID-BUG-------------------------------//

bool Ndas =  (HSFC.y == 1. && HSFC.x <.23);
bool Ndas2 = (HSFtime.r > HSFtime.b && HSFtime.r < 0.5 && HSFtime.b < 0.2);
if(Ndas == true){
HSdiff.rgb += Tch*.1;
HSdiff.rgb *= vec3(1.3);
highp float FEN = clamp(length(HSW)/RENDER_DISTANCE* 1.,.3,2.);
highp v3 FENon = mix(HSdiff.rgb, HSFtime.rgb*v3(1.6,.5,.1),FEN);
HSdiff.rgb = FENon;}
if(Ndas2 == hooh){
HSdiff.rgb += Tch*.1;
HSdiff.rgb *= vec3(1.3);
highp float NEF = clamp(length(HSW)/RENDER_DISTANCE* 1.,.3,2.);
highp v3 NFon = mix(HSdiff.rgb, HSFtime.rgb*v3(1.6,.5,.1),NEF);
HSdiff.rgb = NFon;}
bool Ndes = (HSFtime.g > HSFtime.r && HSFtime.r < HSFtime.b && HSFtime.b == 1. && HSFC.x < HSFC.y && HSFC.y == 1.);
bool Ndes2 = (HSFtime.r > HSFtime.g && HSFtime.b > HSFtime.g && HSFtime.r < 0.05 && HSFtime.b < 0.05 && HSFtime.g < 0.05);
if(Ndes == hooh){HSdiff.rgb *= 
v3(.7,1.4,1.5);
v3 END = v3(0.,.0,.7);
highp v3 T_TE = END*pow(shm*2.,5.);
HSdiff.rgb += T_TE;
highp float TEF = clamp(length(HSW) / RENDER_DISTANCE * 1.,.2,.5);
highp v3 TEFon = mix(HSdiff.rgb, HSFtime.rgb*v3(1.,.0,1.), TEF);
HSdiff.rgb = TEFon;}
if(Ndes2 == hooh){HSdiff.rgb *= 
v3(.7,1.4,1.5)*2.;
v3 ENDD = v3(.2,.0,.7);
highp v3 TETEW = ENDD*pow(shm*2.,5.);
HSdiff.rgb += TETEW;
highp float FET = clamp(length(HSW) / RENDER_DISTANCE * 2.,.3,1.);
highp v3 FETon = mix(HSdiff.rgb, HSFtime.rgb*v3(3.,.0,3.), FET);
HSdiff.rgb = FETon;}

//--------------------------------------------------------------------------------//


#ifdef DEBUG
vec2 pos_map = gl_FragCoord.xy/1000.;
if(pos_map.x < .4 && pos_map.y < 1.){
vec3 background_coord = vec3(1);
if(pos_map.y == 0.5) background_coord = v3(0);
if(pos_map.x > .0 && pos_map.x <= .05 && pos_map.y <= HSFtime.r) background_coord.rgb = v3(1.5, .5, .5);
if(pos_map.x > .05 && pos_map.x <= .1 && pos_map.y <= HSFtime.g) background_coord.rgb = v3(.5, 1.5, .5);
if(pos_map.x > .1 && pos_map.x <= .15 && pos_map.y <= HSFtime.b) background_coord.rgb = v3(.5, .5, 1.5);
if(pos_map.x >.2 && pos_map.x <= .25 && pos_map.y <= HSFC.x) background_coord.rgb = v3(1.5, 1.5, .5);
if(pos_map.x > .25 && pos_map.x <= .3 && pos_map.y <= HSFC.y) background_coord.rgb = v3(05, 1.5, 1.5);
HSdiff = mix(HSdiff, vec4(background_coord, 1), .5);}
#endif

#ifdef FOG
HSdiff.rgb = mix( HSdiff.rgb, fogColor.rgb, fogColor.a );
#endif
#endif

gl_FragColor = HSdiff;

#endif // BYPASS_PIXEL_SHADER
}