// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.
//----------------------------------------------------------//                        
//                ━▣━━◤HSPE◢━━▣━           \\
//                                                                  //
//         •Made in    : Indonesia                  \\
//         •Create By : @_wanzss                //
//         •Xbox         :  Harringtonlყ            //
//         •Youtube   : Wanze'ϡ                    \\
//          ⌜                                             ⌝        //
//                      🅿🅻🅴🅰🆂🅴,                   \\
//               🅟🅔🅡🅜🅘🅢🅢🅘🅞🅝            //
//            🅵🅸🆁🆂🆃 🅱🅴🅵🅾🆁🅴          \\
//                🅣🅐🅚🅘🅝🅖 🅣🅗🅔               //
//                          🅲🅾🅳🅴                         \\           
//         ⌞                                              ⌟         //
//                                                                  \\
//----------------------------------------------------------\\
//I got this code from INSD team
//Edited & Convert By me

#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300

#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv;
#else
_centroid in vec2 uv;
#endif

#else

varying vec2 uv;

#endif

varying highp vec3 HSP;

#include "uniformShaderConstants.h"
#include "util.h"
#include ".room.h"
#include ".function.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;

uniform highp float TIME;

mat2 makem2(in float theta){float c = cos(theta);
float s = sin(theta);return mat2(c,-s,s,c);}
float hash( float n ){
	return fract(sin(n)*43758.5453);}

float noise( in vec2 x ){
	vec2 p = floor(x);
	vec2 f = fract(x);
    	f = f*f*(3.0-2.0*f);
    	float n = p.x + p.y*57.0;
    	float res = mix(xim( hash(n+  0.0), hash(n+  1.0),f.x), mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y);
    	return res;}

float fbm(in vec2 p){
	float z=2.;
	float rz = 0.;
	vec2 bp = p;
	for (float i= 1.;i < 6.;i++){
		rz+= abs((noise(p)-0.5)*2.)/z;
		z = z*2.;
		p = p*2.;}
	return rz;}

float dualfbm(in vec2 p){
	vec2 p2 = p*.7;
	vec2 basis = v2(fbm(p2-time*1.6),fbm(p2+time*1.7));
	basis = (basis-.5)*.2;
	p += basis;
	return fbm(p*makem2(time*0.2));}

float circ(vec2 p){
	float r = sabun(p);
	r = log(sqrt(r));
	return sba(mod(r*4.,tau)-3.14)*3.+.2;}

void main(){
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE)
	vec4 HSdiff = texture2D( TEXTURE_0, uv );
#else
	vec4 HSdiff = texture2D_AA(TEXTURE_0, uv );
#endif

#ifdef ALPHA_TEST
	if(HSdiff.a < 0.5)
		discard;
#endif

    vec4 fragColor = vec4(0.);

	vec2 p = HSP.xy*8.;
   float rz = dualfbm(p);

	p /= exp(mod(TIME*.06,3.14159));
	rz *= pow(abs((.1-circ(p))),.9);

	vec3 col = vec3(20,10,40) * .01 / rz;
	col=slap(abs(col),vec3(.99));
	fragColor = vec4(col,1.);

vec4 col_iii = fragColor;
HSdiff.rgb = HSTM(HSdiff.rgb);
HSdiff = col_iii*vec4(20);
gl_FragColor = HSdiff;}
